apiVersion: {{ ds_apivers }}
kind: DaemonSet
metadata:
  labels:
    {{ network_policy_deployment_label }}: {{ fluentd_name }}
  name: {{ fluentd_name }}-{{ target_arch }}
  namespace: {{ namespace }}
spec:
  selector:
    matchLabels:
      name: {{ fluentd_name }}-{{ target_arch }}
  template:
    metadata:
      labels:
        name: {{ fluentd_name }}-{{ target_arch }}
    spec:
      containers:
      - env:
        - name: FLUENT_ELASTICSEARCH_BUFFER_CHUNK_LIMIT_SIZE
          value: {{ fluentd_elasticsearch_chunk_size }}
        - name: FLUENT_ELASTICSEARCH_BUFFER_FLUSH_THREAD_COUNT
          value: "{{ fluentd_elasticsearch_thread_count }}"
        - name: FLUENT_ELASTICSEARCH_HOST
{% if logging_storage_flavor in [ 'elastic', 'elasticsearch' ] %}
          value: {{ elasticsearch_name }}-client.{{ namespace }}.svc.{{ cluster_domain }}
{% else %}
          value: {{ opensearch_name }}-client.{{ namespace }}.svc.{{ cluster_domain }}
{% endif %}
        - name: FLUENT_ELASTICSEARCH_PORT
          value: "9200"
        - name: FLUENT_ELASTICSEARCH_REQUEST_TIMEOUT
          value: {{ fluentd_elasticsearch_request_timeout }}
        - name: FLUENT_ELASTICSEARCH_SCHEME
          value: http
{% if do_exporters %}
        - name: FLUENTD_PROMETHEUS_BIND
          value: 0.0.0.0
        - name: FLUENTD_PROMETHEUS_PATH
          value: /metrics
        - name: FLUENTD_PROMETHEUS_PORT
          value: "9113"
{% endif %}
        - name: FLUENT_UID
          value: "0"
        - name: K8S_NODE_NAME
          valueFrom:
            fieldRef:
              fieldPath: spec.nodeName
        image: {{ (opsimages | json_query("[?name=='fluentd'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        name: fluentd
        resources:
          limits:
            cpu: "{{ fluentd_cpu_limit }}"
            memory: "{{ fluentd_memory_limit }}"
          requests:
            cpu: "{{ fluentd_cpu_request }}"
            memory: "{{ fluentd_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: true
          privileged: true
        volumeMounts:
        - mountPath: /fluentd/etc/kubernetes.conf
          name: config
          subPath: kubernetes.conf
        - mountPath: /fluentd/etc/systemd.conf
          name: config
          subPath: systemd.conf
{% if do_exporters %}
        - mountPath: /fluentd/etc/conf.d
          name: empty
        - mountPath: /fluentd/etc/conf.d/prometheus.conf
          name: config
          subPath: prometheus.conf
{% endif %}
        - mountPath: /fluentd/entrypoint.sh
          name: config
          subPath: entrypoint.sh
        - mountPath: /etc/localtime
          name: localtime
          readOnly: true
        - mountPath: /run/log/journal
          name: runlogjournal
          readOnly: true
        - mountPath: /var/log
          name: varlog
      nodeSelector:
{% for sel in fluentd_collect_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
        kubernetes.io/arch: {{ target_arch }}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-monitoring
{% endif %}
{% if (k8s_flavor == 'kubernetes' and do_podsecuritypolicy) or k8s_flavor == 'openshift' %}
      serviceAccountName: {{ fluentd_name }}
{% else %}
      serviceAccountName: default
{% endif %}
      terminationGracePeriodSeconds: 60
      tolerations:
      - operator: Exists
      volumes:
      - name: config
        projected:
          defaultMode: 420
          sources:
          - configMap:
              items:
              - key: kubernetes.conf
                path: kubernetes.conf
              name: {{ fluentd_name }}
          - configMap:
              items:
              - key: systemd.conf
                path: systemd.conf
              name: {{ fluentd_name }}
          - configMap:
              items:
              - key: entrypoint.sh
                mode: 493
                path: entrypoint.sh
              name: {{ fluentd_name }}
{% if do_exporters %}
          - configMap:
              items:
              - key: prometheus.conf
                path: prometheus.conf
              name: {{ fluentd_name }}
      - emptyDir: {}
        name: empty
{% endif %}
      - hostPath:
          path: /etc/localtime
          type: ""
        name: localtime
      - hostPath:
          path: /run/log/journal
          type: ""
        name: runlogjournal
      - hostPath:
          path: /var/log
          type: ""
        name: varlog
  updateStrategy:
    type: RollingUpdate
